<template>
  <v-container>
    <v-dialog
      v-model="newDirectoryDialog"
      @click:outside="close"
      @keydown.esc="close"
      max-width="450px"
    >
      <v-card>
        <v-card-title>
          <v-row justify="center"
            ><v-icon class="directory" x-large color="primary">mdi-folder-plus</v-icon>
          </v-row>
        </v-card-title>
        <v-card-subtitle>
          <v-row justify="center">
            <span class="sub secondary--text">Criar novo diretório</span>
            <v-col cols="10">
              <v-text-field
                autofocus
                v-model="name"
                :error-messages="errorMessage"
                @keydown="cleanErrorMessage"
                label="Nome do diretório"
              ></v-text-field>
            </v-col>
          </v-row>
        </v-card-subtitle>
        <v-card-text>
          <v-card-actions>
            <v-row justify="center">
              <v-btn color="primary" text @click="close">Cancelar</v-btn>
              <v-btn
                :disabled="!name"
                color="primary"
                class="ml-4"
                elevation="0"
                @click="newDirectory"
                >Criar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
export default {
  name: 'CreateNewDirectory',

  props: {
    newDirectoryDialog: {
      type: Boolean,
      default: false,
    },
    folders: {
      type: Array,
    },
  },
  data: () => ({
    name: '',
    errorMessage: '',
  }),

  computed: {},
  watch: {},

  methods: {
    close() {
      this.name = ''
      this.cleanErrorMessage()
      this.$emit('closeDirectoryDialog')
    },
    newDirectory() {
      let check = 0
      if (this.name != '') {
        this.folders.forEach((e) => {
          if (e.name == this.name) {
            check++
            this.errorMessage = 'Já existe um diretório com esse nome'
            return
          }
        })
      } else {
        this.errorMessage = 'Não é possível criar um diretório sem nome'
        return
      }
      if (check == 0) {
        this.$emit('newDirectory', this.name)
        this.name = ''
        this.cleanErrorMessage()
      }
    },
    cleanErrorMessage() {
      this.errorMessage = ''
    },
  },
}
</script>
<style>
.deleteTitleFont {
  transform: scale(0.75);
}
.iconTitle {
  padding-top: 15px;
  transform: scale(1.5);
}
.directory {
  padding-top: 15px;
  padding-bottom: 25px;
  transform: scale(1.5);
}
.sub {
  font-size: 1.3em;
}
</style>
